unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, idglobal, IdCoderMIME,
  Data.Bind.Components, Data.Bind.ObjectScope, REST.Client,
  REST.Authenticator.OAuth, IdIOHandlerSocket, IdIOHandlerStack, IdSSL,
  IdSSLOpenSSL, IdIOHandler, IdIOHandlerStream, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, Vcl.ExtCtrls, ShellAPI, System.UITypes, DateUtils;

type
  TForm1 = class(TForm)
    edNotToken: TEdit;
    memLog: TMemo;
    Button2: TButton;
    edClientID: TEdit;
    edClientSecret: TEdit;
    btAuth: TButton;
    Label1: TLabel;
    Button4: TButton;
    Button5: TButton;
    edCarneID: TEdit;
    edChargeID: TEdit;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    btGetCharge: TButton;
    Button10: TButton;
    Button11: TButton;
    edCarneChargeID: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    edParcel: TEdit;
    Label4: TLabel;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    btn1: TButton;
    btn2: TButton;
    cbSandBox: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Button1: TButton;
    pnBoleto: TPanel;
    lblURL: TLabel;
    Label12: TLabel;
    lblBoleto: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure btAuthClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure btGetChargeClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure lblURLClick(Sender: TObject);
  private
    { Private declarations }
    procedure CheckAuth;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses GNRequest, GNCharge, GNCarnet, GNNotification,
  GNPaymentBillet, GNLib;

procedure TForm1.btn1Click(Sender: TObject);
begin
  try
    if TGNCarnet.HistoryCarnet(strtofloat(edCarneID.text), 'demo carnet history').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('NOK! '+ e.message);
  end;
end;

procedure TForm1.btn2Click(Sender: TObject);
begin
  try
    if TGNCharge.HistoryCharge(strtofloat(edChargeID.text), 'demo charge history').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('NOK! '+ e.message);
  end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  res: TGNCarneDetail;
begin
  CheckAuth;
  res := TGNCarnet.GetCarnet(strtoint(edCarneID.Text));

  memLog.Text := res.ToJsonString;
  res.Free;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  res: TGNChargeCarnet;
begin
  res := TGNCarnet.GetCharge(strtofloat(edCarneChargeID.text));

  if res <> nil then
  begin
    memLog.Text := res.ToJsonString;
    showmessage(res.data.customer.name);
  end;

  res.Free;

end;

procedure TForm1.Button12Click(Sender: TObject);
var
  res: TGNCodeResponse;
  metadata: TGNMetadata;
begin
  metadata := TGNMetadata.Create;

  //metadata.custom_id := '000001';
  metadata.notification_url := 'http://jbserver.ddns.net:8083/gerencianetapiTESTE';

  try
    res := TGNCharge.UpdateMetadata(strtofloat(edChargeID.text),metadata);

    if res.code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('Fail! '+ e.message);
  end;

  metadata.Free;

end;

procedure TForm1.Button13Click(Sender: TObject);
var
  metadata: TGNMetadata;
begin
  metadata := TGNMetadata.Create;

  metadata.custom_id := '000001';
  metadata.notification_url := 'http://jbserver.ddns.net:8083/gerencianetapiTESTE';

  try
    if TGNCarnet.UpdateMetadata(strtofloat(edCarneID.text),metadata).code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('Fail! '+ e.message);
  end;

  metadata.Free;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  try
    if TGNCharge.BilletUpdate(strtofloat(edChargeID.text),'2016-10-18').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('Fail! '+ e.message);
  end;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  try
    if TGNCarnet.UpdateParcel(strtofloat(edCarneID.text),strtoint(edParcel.text),'2016-10-22').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('Fail! '+ e.message);
  end;
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  try
    if TGNCarnet.CancelParcel(strtofloat(edCarneID.text), strtoint(edParcel.text)).code = 200 then
      Showmessage('Parcel canceled!')
  except on e:exception do
    Showmessage('Not Canceled! '+ e.message);
  end;
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  try
    if TGNCarnet.ResendCarnet(strtofloat(edCarneID.text), 'sac@jbsolcuoes.net').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('NOK! '+ e.message);
  end;
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
  try
    if TGNCarnet.ResendCarneParcel(strtofloat(edCarneID.text), strtoint(edParcel.text), 'sac@jbsolcuoes.net').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('NOK! '+ e.message);
  end;
end;

procedure TForm1.Button19Click(Sender: TObject);
begin
  try
    if TGNCharge.ResendCharge(strtofloat(edChargeID.text), 'sac@jbsolcuoes.net').code = 200 then
      Showmessage('OK!')
  except on e:exception do
    Showmessage('NOK! '+ e.message);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  edClientID.Text := 'Client_Id_3ddefd5c7fb88bca7de41924338baffc2ea95491';
  edClientSecret.Text := 'Client_Secret_48ba6803b45b365cc8f9ec1b799367387d5278bf';

  btAuth.Click;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  notify: TGNNotificationResult;
  charge: TGNChargeDetail;
  carnecharge: TGNChargeCarnet;
  I: Integer;
begin
  charge:= nil;
  notify := nil;
  carnecharge := nil;
  try
    try
      memLog.Clear;
      application.ProcessMessages;

      notify := GNNotificationGet(edNotToken.Text);

      if notify = nil then
        exit;

      for i := 0 to length(notify.data) -1 do
      begin
        if notify.data[i].&type = 'carnet' then
          memLog.lines.Add('Receiving carnet...')
        else if notify.data[i].&type = 'carnet_charge' then
        begin
          carnecharge := TGNCarnet.GetCharge(notify.data[i].identifiers.charge_id);

          memLog.lines.Add('Charge Id: '+ floattostr(notify.data[i].identifiers.charge_id) + ' Barcode: '+ carnecharge.data.payment.carnet.barcode );
        end
        else if notify.data[i].&type = 'charge' then
        begin
          charge := TGNCharge.GetCharge(notify.data[i].identifiers.charge_id);

          //se tem pagamento adicionado
          if charge.data.payment <> nil then
            memLog.lines.Add('Charge Id: '+ floattostr(notify.data[i].identifiers.charge_id) + ' Barcode: '+ charge.data.payment.banking_billet.barcode + ' Status: '+ notify.data[i].status.current)
          else
            memLog.lines.Add('Charge Id: '+ floattostr(notify.data[i].identifiers.charge_id) + ' Status: '+ notify.data[i].status.current);
        end;
      end;

      Showmessage('Concludo!');

    except on e: exception do
      ShowMessage(e.message);
    end;

  finally
    if notify <> nil then
      notify.Free;
    if charge <> nil then
      charge.Free;
    if carnecharge <> nil then
      carnecharge.Free;
  end;
end;

procedure TForm1.btAuthClick(Sender: TObject);
begin
  if (Trim(edClientID.Text) = '') then
  begin
    ShowMessage('Informe o ClientID!');
    if edClientID.CanFocus then
      edClientID.SetFocus;
    abort;
  end;

  if (Trim(edClientSecret.Text) = '') then
  begin
    ShowMessage('Informe o Client Secret!');
    if edClientSecret.CanFocus then
      edClientSecret.SetFocus;
    abort;
  end;
  try
    if not GNAuthorization(edClientID.text,edClientSecret.text, cbSandBox.checked) then
    begin
      memLog.Text := 'GNAuthorization fail.';
      exit;
    end;

    if assigned(GNAccessToken) then
      memLog.Text := GNAccessToken.ToJsonString;
  except on e:exception do
    ShowMessage('Error: '+ e.message);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  carne: TGNCarnet;
  res: TGNCarneResponse;
  item: TGNCarnetItem;
  I: Integer;
begin
  CheckAuth;
  carne := TGNCarnet.Create;
  //cliente
  carne.customer.name := 'JOSE SILVA';
  carne.customer.cpf  := '42561401235';
  carne.customer.phone_number := '22996064279';
  //endereco
  carne.customer.address.street := 'gilberto cardoso';
  carne.customer.address.number := 117;
  carne.customer.address.complement := 'apto 204';
  carne.customer.address.neighborhood := 'pq california';
  carne.customer.address.city    := 'campos';
  carne.customer.address.state   := 'RJ';
  carne.customer.address.zipcode := '28015140';
  //item do carne
  item := TGNCarnetItem.Create;
  item.amount := 1;
  item.name  := 'TESTE CARNE';
  item.value := ToGNvalue(15.00);
  carne.AddItem(item);
  //vencimento e parcelas
  carne.expire_at := formatdatetime('YYYY-MM-DD', now + 30);
  carne.repeats   := 4;
  carne.split_items := false;
  //instrues
  carne.AddInstruction('Linha 1');
  carne.AddInstruction('Linha 2');
  carne.AddInstruction('Linha 3');
  carne.AddInstruction('Linha 4');
  //metadata
  carne.metadata.custom_id := '000001';
  carne.metadata.notification_url := 'http://jbserver.ddns.net:8083/gerencianetapi';

  res := carne.CreateCarnet();

  if res <> nil then
  begin
    for I := 0 to length(res.data.charges) - 1 do
    begin
      memLog.Lines.Add( floattostr( res.data.charges[i].charge_id));
      memLog.Lines.Add( res.data.charges[i].url);
    end;

//    memLog.Text := res.ToJsonString;
    showmessage('Carne criado! ID: '+ floattostr(res.data.carnet_id) + ' status: ' + res.data.status );
    edCarneID.Text := floattostr(res.data.carnet_id);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  try
    if TGNCarnet.CancelCarnet(strtofloat(edCarneID.text)).code = 200 then
      Showmessage('Carne canceled!')
  except on e:exception do
    Showmessage('Not Canceled! '+ e.message);
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  try
    if TGNCharge.CancelCharge(strtofloat(edChargeID.text)).code = 200 then
      Showmessage('Charge canceled!')
  except on e:exception do
    Showmessage('Not Canceled! '+ e.message);
  end;


end;

procedure TForm1.Button7Click(Sender: TObject);
var
  charge: TGNCharge;
  item: TGNChargeItem;
  res: TGNChargeResponse;
begin
  CheckAuth;
  //transao
  charge := TGNCharge.Create;
  res := nil;
  try
    //item da transao
    item := TGNChargeItem.Create;
    item.amount := 1;
    item.name  := 'Descrio do item da transao';

    //gnvalue converte valor no formato do GerenciaNet.
    //Valor no formato GerenciaNet precisa ser passado como nmero inteiro com
    //no mnimo 4 dgitos, sendo os ltimos 2 as casas decimais
    item.Value := ToGNValue(151.52); //ou 15152

    charge.AddItem(item);
    charge.metadata.custom_id := '0001';
    charge.metadata.notification_url := 'http://jbserver.ddns.net:8083/gerencianetapi';

    res := charge.CreateCharge();

    if res <> nil then
      showmessage('Charge Created: '+ floattostr(res.data.charge_id) + ' status: '+ res.data.status);

    edChargeID.Text := floattostr(res.data.charge_id);
  finally
    charge.Free;
    res.Free;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  res: TGNPaymentBilletResponse;
  boleto: TGNPaymentBillet;
begin
  CheckAuth;
  boleto := TGNPaymentBillet.Create;
  boleto.payment.banking_billet.customer.name := 'JOSE SILVA';
  boleto.payment.banking_billet.customer.cpf  := '06344894458';
  boleto.payment.banking_billet.customer.birth := '2017-01-15';
  boleto.payment.banking_billet.customer.email := 'josebenedito@gmail.com';
  boleto.payment.banking_billet.customer.phone_number := '22996064279';
  boleto.payment.banking_billet.expire_at := '2017-10-15';
  boleto.payment.banking_billet.AddInstruction('Teste de Instrucoes de Pagamento');
  boleto.payment.banking_billet.configurations := nil;
  boleto.payment.banking_billet.customer.juridical_person := nil;
//  boleto.payment.banking_billet.customer.juridical_person.corporate_name := 'JBS SOLUCOES';
//  boleto.payment.banking_billet.customer.juridical_person.cnpj := '17638359000191';
  boleto.payment.banking_billet.customer.address := nil;
  boleto.payment.banking_billet.discount := nil;
  boleto.payment.banking_billet.customer.post_office_address := nil;

  res := TGNCharge.PayBillet(strtofloat(edChargeID.text),boleto);

  if res <> nil then
  begin
    memLog.Text := res.ToJsonString;
    showmessage('Payment OK');
    btGetCharge.Click;
    res.Free;
  end;
end;

procedure TForm1.btGetChargeClick(Sender: TObject);
var
  res: TGNChargeDetail;
  value: double;
begin
  CheckAuth;
  pnBoleto.Visible := false;
  lblBoleto.Caption := 'Billet';
  lblURL.caption := 'URL';

  res := TGNCharge.GetCharge(strtofloat(edChargeID.text));

  try
    if res <> nil then
    begin
      memLog.Text := res.ToJsonString;

      //recupera valor do formato gerencianet para float.
      value := GNValue(res.data.items[0].Value);

      if res.data.payment <> nil then
        if res.data.payment.banking_billet <> nil then
        begin
          pnBoleto.Visible := true;
          lblBoleto.Caption := 'Barcode: '+ res.data.payment.banking_billet.barcode;
          lblURL.Caption := res.data.payment.banking_billet.link;
        end;

      showmessage(res.data.customer.name + #13#10 + res.data.items[0].Name + ' Valor: '+ floattostr(value));
    end;

  finally
    res.Free;
  end;

end;

procedure TForm1.CheckAuth;
var
  dtexp: TDateTime;
begin
  if not Assigned(GNAccessToken) then
  begin
    btAuth.Click;
    exit;
  end;

  dtExp := IncMillisecond(GNAccessLastAuth,round(GNAccessExpireIn * 1000));

  if dtExp < now then
    btAuth.Click;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF DEBUG}
  edClientID.Text := 'Client_Id_050a470ee407373bbb6a405d22d64ece9e016455';
  edClientSecret.Text := 'Client_Secret_e512a508f0074d7c8bbfadb3f2b89b1c1519c383';
  {$ENDIF}
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  MessageDlg('Demonstrao de integrao de biblioteca Delphi com API do GerenciaNet.' + #13#10 + #13#10 +
             #13#10 +
             'www.jbsolucoes.net' + #13#10 +
             'sac@jbsolucoes.net' + #13#10 +
             ' JBS Solues 2023', mtInformation, [mbok],0);
end;

procedure TForm1.lblURLClick(Sender: TObject);
var
  MyLink: string;
begin
  if lblURL.caption = 'URL'  then
    exit;

  MyLink := lblURL.Caption;
  ShellExecute(Application.Handle, PChar('open'), PChar(MyLink),
   nil, nil, SW_SHOW);
end;

end.
